package com.nisum.service;

import com.nisum.dao.Dao;
import com.nisum.dto.EmployeeDto;
import com.nisum.model.Employee;
import com.nisum.model.impl.EmployeeImp;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.Optional;

@Service
public class EmployeeService {

  @Autowired
  @Qualifier(value = "EmployeeDao")
  private Dao employeeDao;

  public Collection<EmployeeImp> getAllEmployees() {
    return employeeDao.getAll();
  }

  public Optional getEmployeeId(int id) {
    return employeeDao.getById(id);
  }

  public void createEmployee(EmployeeDto employeeDto) {
    EmployeeImp newEmployee = new EmployeeImp();
    newEmployee.setFirstName(employeeDto.getFirstName());
    newEmployee.setLastName((employeeDto.getLastName()));
//    newEmployee.setJobRole(newEmployeeData.getJobTitle());
    employeeDao.save(newEmployee);
  }

  public void editEmployee(Integer id) {
    Optional employeeToEdit = employeeDao.getById(id);
    if(employeeToEdit.isPresent()) {
      employeeDao.update(employeeToEdit);
    }
  }
}
